/*
 *  TOPPERS/SSP Kernel
 *      Smallest Set Profile Kernel
 *
 *  Copyright (C) 2011 by Meika Sugimoto
 * 
 *  嵭Ԥϡʲ (1)(4) ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣѡ
 *  ۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ǤǺۤˤϡۤȼɥȡѼԥ
 *      ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ̵
 *      ڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ǤʤǺۤˤϡΤ줫ξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡޤ
 *      ܥեȥΥ桼ޤϥɥ桼Τʤͳ˴
 *      ᤫ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪФ
 *  ŬޤơʤݾڤԤʤޤܥեȥ
 *  ˤľŪޤϴŪʤ»˴ؤƤ⡤Ǥ
 *  ʤ
 * 
 */

#ifndef TOPPERS_TIME_EVENT_H
#define TOPPERS_TIME_EVENT_H

#include "kernel_impl.h"
#include "queue.h"

/* ٥Ȼ */
typedef ulong_t	EVTTIM;

/*
 *  ।٥ȥХåؿ
 */

typedef void (*CBACK)(uintptr_t arg);

/*
 *  ।٥ȥ֥å
 *
 *  ե졼ˤä롥
 */

/* ।٥ȥ֥åΥ */
extern const uint_t tnum_tmevt_queue;

/* ।٥ȥ塼 */
extern QUEUE tmevt_queue[];

/* ।٥Ȼ */
extern EVTTIM tmevt_time[];

/* ।٥ȤΥХå */
extern CBACK tmevt_callback[];

/* ।٥ȥХåΰ */
extern uintptr_t tmevt_arg[];


/* ߤΥƥ */
extern EVTTIM current_time;


/*
 *  ।٥Ȥν
 */
extern void
initialize_time_event(void);

/*
 *  ।٥ȤϿ
 */
extern void
time_event_enqueue(ID tmevtid , EVTTIM evttim , CBACK callback , uintptr_t arg);

/*
 *  ।٥Ȥκ
 */
extern void
time_event_dequeue(ID tmevtid);

/*
 *  ƥåζ
 */
extern void
signal_time(void);


#endif	/* TOPPERS_TIME_EVENT_H */
